#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK20x20x20NN0x0x0_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=20, NB=20, KB=20, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=2, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 40;
   const float *stN = B + (((ldb) << 5)+((ldb) << 3));
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (((lda) << 1));
   const int incAm = 4 - (((lda) << 5)+((lda) << 3)), incAn = -40;
   #define incBk 2
   const int incBm = -40, incBn = (((ldb) << 2));
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 40;
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(((ldb) << 1));
   register int k;
   register float rA0, rA1;
   register float rB0, rB1;
   register float m0, m1, m2, m3;
   register float rC0_0, rC1_0, rC0_1, rC1_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         rB1 = *pB1;
         m0 = rA0 * rB0;
         m1 = rA1 * rB0;
         m2 = rA0 * rB1;
         m3 = rA1 * rB1;
         pA0 += incAk0;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[2];
         rB1 = pB1[2];

         pB0 += (incBk0);
         pB1 += (incBk0);
/*
 *       Peel first 1 iterations for C assignment
 */
         rC0_0 = m0;
         m0 = rA0 * rB0;
         rC1_0 = m1;
         m1 = rA1 * rB0;
         rC0_1 = m2;
         m2 = rA0 * rB1;
         rC1_1 = m3;
         m3 = rA1 * rB1;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[2];
         rB1 = pB1[2];
         pB0 += incBk;
         pB1 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 17; k++) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC1_0 += m1;
            m1 = rA1 * rB0;
            rC0_1 += m2;
            m2 = rA0 * rB1;
            rC1_1 += m3;
            m3 = rA1 * rB1;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rA1 = pA0[2];
            rB1 = pB1[2];
            pB0 += incBk;
            pB1 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pA0 += incAk0;
         rC0_0 += m0;
         rC1_0 += m1;
         rC0_1 += m2;
         rC1_1 += m3;
         pB0 += incBk0;
         pB1 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
