#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK20x20x20TT0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=20, NB=20, KB=20, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=2, ku=20, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + (((lda) << 5)+((lda) << 3));
   const float *stN = B + 40;
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 40
   const int incAm = ((((((lda) << 1)) - 20) << 1)), incAn = -(((lda) << 5)+((lda) << 3));
   const int incBk = (((ldb) << 1)), incBm = -(((ldb) << 5)+((ldb) << 3));
   #define incBn 4
   const int incAk0 = ((incAk) / 20);
   #define incBk0 incBk
   #define incCm 4
   const int incCn = (((ldc) << 2)) - 40;
   float *pC0=C, *pC1=pC0+(((ldc) << 1));
   const float *pA0=A, *pA1=pA0+(((lda) << 1));
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0, rB1;
   register float m0, m1, m2, m3, m4, m5, m6, m7;
   register float rC0_0, rC1_0, rC0_1, rC1_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[2];
         rC1_1 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rB1 = pB0[2];
         m0 = rA0 * rB0;
         m1 = rA1 * rB0;
         m2 = rA0 * rB1;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rB1 = pB0[2];
         m4 = rA0 * rB0;
         m5 = rA1 * rB0;
         m6 = rA0 * rB1;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rA1 = pA1[4];
         rB1 = pB0[2];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         rA1 = pA1[6];
         rB1 = pB0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[8];
         rB0 = *pB0;
         rA1 = pA1[8];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[10];
         rB0 = *pB0;
         rA1 = pA1[10];
         rB1 = pB0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[12];
         rB0 = *pB0;
         rA1 = pA1[12];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[14];
         rB0 = *pB0;
         rA1 = pA1[14];
         rB1 = pB0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[16];
         rB0 = *pB0;
         rA1 = pA1[16];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[18];
         rB0 = *pB0;
         rA1 = pA1[18];
         rB1 = pB0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[20];
         rB0 = *pB0;
         rA1 = pA1[20];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[22];
         rB0 = *pB0;
         rA1 = pA1[22];
         rB1 = pB0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[24];
         rB0 = *pB0;
         rA1 = pA1[24];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[26];
         rB0 = *pB0;
         rA1 = pA1[26];
         rB1 = pB0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[28];
         rB0 = *pB0;
         rA1 = pA1[28];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[30];
         rB0 = *pB0;
         rA1 = pA1[30];
         rB1 = pB0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[32];
         rB0 = *pB0;
         rA1 = pA1[32];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[34];
         rB0 = *pB0;
         rA1 = pA1[34];
         rB1 = pB0[2];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[36];
         rB0 = *pB0;
         rA1 = pA1[36];
         rB1 = pB0[2];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC0_1 += m2;
         m2 = rA0 * rB1;
         rC1_1 += m3;
         m3 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[38];
         rB0 = *pB0;
         rA1 = pA1[38];
         rB1 = pB0[2];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC0_1 += m6;
         m6 = rA0 * rB1;
         rC1_1 += m7;
         m7 = rA1 * rB1;
         pB0 += incBk;
         rC0_0 += m0;
         rC1_0 += m1;
         rC0_1 += m2;
         rC1_1 += m3;
         rC0_0 += m4;
         rC1_0 += m5;
         rC0_1 += m6;
         rC1_1 += m7;
         pA0 += incAk;
         pA1 += incAk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         *pC1 = rC0_1;
         pC1[2] = rC1_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
