#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x72NN1x1x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=72, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 6)+((lda) << 3)), incAn = -(Mb);
   #define incBk 1
   const int incBm = -72, incBn = (ldb);
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      ATL_pfl1R(pfA+64);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pA0 += incAk0;
         rA0 = *pA0;
         rB0 = pB0[1];

         pB0 += (incBk0);
         for (k=70; k; k--) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            pB0 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pA0 += incAk0;
         rC0_0 += m0;
         pB0 += incBk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK0x0x72NN9x1x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=72, 
 * lda=0, ldb=0, ldc=0, mu=9, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/9)*9;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 9 - (((lda) << 6)+((lda) << 3)), incAn = -(Mb);
   #define incBk 1
   const int incBm = -72, incBn = (ldb);
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 9
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8;
   register double rB0;
   register double m0, m1, m2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         ATL_pfl1R(pfA+16);
         ATL_pfl1R(pfA+24);
         ATL_pfl1R(pfA+32);
         ATL_pfl1R(pfA+40);
         ATL_pfl1R(pfA+48);
         ATL_pfl1R(pfA+56);
         ATL_pfl1R(pfA+64);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            rA3 = pA0[3];
            rA4 = pA0[4];
            rA5 = pA0[5];
            rA6 = pA0[6];
            rA7 = pA0[7];
            rA8 = pA0[8];
            m0 = rA0 * rB0;
            m1 = rA1 * rB0;
            m2 = rA2 * rB0;

            for (k=71; k; k--) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rA1 = pA0[1];
               rA2 = pA0[2];
               rA3 = pA0[3];
               rA4 = pA0[4];
               rA5 = pA0[5];
               rA6 = pA0[6];
               rA7 = pA0[7];
               rA8 = pA0[8];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               pB0 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA3 * rB0;
            rC1_0 += m1;
            m1 = rA4 * rB0;
            rC2_0 += m2;
            m2 = rA5 * rB0;
            rC3_0 += m0;
            m0 = rA6 * rB0;
            rC4_0 += m1;
            m1 = rA7 * rB0;
            rC5_0 += m2;
            m2 = rA8 * rB0;
            pA0 += incAk0;
            rC6_0 += m0;
            rC7_0 += m1;
            rC8_0 += m2;
            pB0 += incBk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            rC4_0 *= rB0;
            rC5_0 *= rB0;
            rC6_0 *= rB0;
            rC7_0 *= rB0;
            rC8_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x72NN1x1x1_aX_bX(k, N, 72, alpha, ca + (Mb), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x72NN1x2x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=72, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=2, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N>>1)<<1;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 6)+((lda) << 3)), incAn = -(Mb);
   #define incBk 1
   const int incBm = -72, incBn = (((ldb) << 1));
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 1
   const int incCn = (((ldc) << 1)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb);
   register int k;
   register double rA0;
   register double rB0, rB1;
   register double m0, m1;
   register double rC0_0, rC0_1;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         ATL_pfl1R(pfA+16);
         ATL_pfl1R(pfA+24);
         ATL_pfl1R(pfA+32);
         ATL_pfl1R(pfA+40);
         ATL_pfl1R(pfA+48);
         ATL_pfl1R(pfA+56);
         ATL_pfl1R(pfA+64);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = *pB1;
            m0 = rA0 * rB0;
            m1 = rA0 * rB1;
            pA0 += incAk0;
            rA0 = *pA0;
            rB0 = pB0[1];
            rB1 = pB1[1];

            pB0 += (incBk0);
            pB1 += (incBk0);
            for (k=70; k; k--) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pA0 += incAk;
               rA0 = *pA0;
               rB0 = pB0[1];
               rB1 = pB1[1];
               pB0 += incBk;
               pB1 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            pA0 += incAk0;
            rC0_0 += m0;
            rC0_1 += m1;
            pB0 += incBk0;
            pB1 += incBk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            pC0 += incCm;
            pC1 += incCm;
            pA0 += incAm;
            pB0 += incBm;
            pB1 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pA0 += incAn;
         pB0 += incBn;
         pB1 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK0x0x72NN1x1x1_aX_bX(M, k, 72, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x72NN0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=72, 
 * lda=0, ldb=0, ldc=0, mu=9, nu=2, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/9)*9;
   const int Nb = (N>>1)<<1;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 9 - (((lda) << 6)+((lda) << 3)), incAn = -(Mb);
   #define incBk 1
   const int incBm = -72, incBn = (((ldb) << 1));
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 9
   const int incCn = (((ldc) << 1)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8;
   register double rB0, rB1;
   register double m0, m1;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1, rC8_1;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+8);
            ATL_pfl1R(pfA+16);
            ATL_pfl1R(pfA+24);
            ATL_pfl1R(pfA+32);
            ATL_pfl1R(pfA+40);
            ATL_pfl1R(pfA+48);
            ATL_pfl1R(pfA+56);
            ATL_pfl1R(pfA+64);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = BetaAlpha;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC2_0 = pC0[2];
               rC2_0 *= rA0;
               rC3_0 = pC0[3];
               rC3_0 *= rA0;
               rC4_0 = pC0[4];
               rC4_0 *= rA0;
               rC5_0 = pC0[5];
               rC5_0 *= rA0;
               rC6_0 = pC0[6];
               rC6_0 *= rA0;
               rC7_0 = pC0[7];
               rC7_0 *= rA0;
               rC8_0 = pC0[8];
               rC8_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC2_1 = pC1[2];
               rC2_1 *= rA0;
               rC3_1 = pC1[3];
               rC3_1 *= rA0;
               rC4_1 = pC1[4];
               rC4_1 *= rA0;
               rC5_1 = pC1[5];
               rC5_1 *= rA0;
               rC6_1 = pC1[6];
               rC6_1 *= rA0;
               rC7_1 = pC1[7];
               rC7_1 *= rA0;
               rC8_1 = pC1[8];
               rC8_1 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[1];
               rA2 = pA0[2];
               rA3 = pA0[3];
               rA4 = pA0[4];
               rA5 = pA0[5];
               rA6 = pA0[6];
               rA7 = pA0[7];
               rA8 = pA0[8];
               m0 = rA0 * rB0;
               rB1 = *pB1;
               m1 = rA1 * rB0;

               for (k=71; k; k--) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pA0 += incAk;
                  rA0 = *pA0;
                  rB0 = pB0[1];
                  rA1 = pA0[1];
                  rA2 = pA0[2];
                  rA3 = pA0[3];
                  rA4 = pA0[4];
                  rA5 = pA0[5];
                  rA6 = pA0[6];
                  rA7 = pA0[7];
                  rA8 = pA0[8];
                  rB1 = pB1[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  pB0 += incBk;
                  pB1 += incBk;
               } /* end K-loop */
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rC2_0 += m0;
               m0 = rA4 * rB0;
               rC3_0 += m1;
               m1 = rA5 * rB0;
               rC4_0 += m0;
               m0 = rA6 * rB0;
               rC5_0 += m1;
               m1 = rA7 * rB0;
               rC6_0 += m0;
               m0 = rA8 * rB0;
               rC7_0 += m1;
               m1 = rA0 * rB1;
               rC8_0 += m0;
               m0 = rA1 * rB1;
               rC0_1 += m1;
               m1 = rA2 * rB1;
               rC1_1 += m0;
               m0 = rA3 * rB1;
               rC2_1 += m1;
               m1 = rA4 * rB1;
               rC3_1 += m0;
               m0 = rA5 * rB1;
               rC4_1 += m1;
               m1 = rA6 * rB1;
               rC5_1 += m0;
               m0 = rA7 * rB1;
               rC6_1 += m1;
               m1 = rA8 * rB1;
               pA0 += incAk0;
               rC7_1 += m0;
               rC8_1 += m1;
               pB0 += incBk0;
               pB1 += incBk0;
               rB0 = alpha;
               rC0_0 *= rB0;
               rC0_1 *= rB0;
               rC1_0 *= rB0;
               rC1_1 *= rB0;
               rC2_0 *= rB0;
               rC2_1 *= rB0;
               rC3_0 *= rB0;
               rC3_1 *= rB0;
               rC4_0 *= rB0;
               rC4_1 *= rB0;
               rC5_0 *= rB0;
               rC5_1 *= rB0;
               rC6_0 *= rB0;
               rC6_1 *= rB0;
               rC7_0 *= rB0;
               rC7_1 *= rB0;
               rC8_0 *= rB0;
               rC8_1 *= rB0;
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               pC0[2] = rC2_0;
               pC0[3] = rC3_0;
               pC0[4] = rC4_0;
               pC0[5] = rC5_0;
               pC0[6] = rC6_0;
               pC0[7] = rC7_0;
               pC0[8] = rC8_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               pC1[2] = rC2_1;
               pC1[3] = rC3_1;
               pC1[4] = rC4_1;
               pC1[5] = rC5_1;
               pC1[6] = rC6_1;
               pC1[7] = rC7_1;
               pC1[8] = rC8_1;
               pC0 += incCm;
               pC1 += incCm;
               pA0 += incAm;
               pB0 += incBm;
               pB1 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pA0 += incAn;
            pB0 += incBn;
            pB1 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_dJIK0x0x72NN9x1x1_aX_bX(M, k, 72, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_dJIK0x0x72NN1x2x1_aX_bX(k, Nb, 72, alpha, ca + (Mb), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
