#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x0TT1x1x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const double *stM = A + (lda*Mb);
   const double *stN = B + (Nb);
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 1
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   const int incBk = (ldb), incBm = -(Kb*ldb);
   #define incBn 1
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=K; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pB0 += incBk;
            pA0 += incAk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x0TT1x1x4_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   #define Kb K
   const int Kloop = ((K-2)>>2)<<2, kr = K - Kloop - 2;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (Nb);
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   const int incBk = (ldb), incBm = -(Kb*ldb);
   #define incBn 1
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double m0;
   register double rC0_0;
   if (K < 3)
   {
      ATL_dJIK0x0x0TT1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         pB0 += incBk0;
         rA0 = pA0[1];
         rB0 = *pB0;

         pA0 += (incAk0);
         for (k=Kloop; k; k -= 4) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            pA0 += incAk;
         } /* end K-loop */
         switch(kr)
         {
         case 1:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            pA0 += (incAk0);
            break;
         case 2:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            pA0 += (((incAk0) << 1));
            break;
         case 3:
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rC0_0 += m0;
            m0 = rA0 * rB0;
            pB0 += incBk;
            rA0 = pA0[3];
            rB0 = *pB0;
            pA0 += (((incAk0) << 1)+incAk0);
            break;
         case 0: ;
         }
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         pB0 += incBk0;
         rC0_0 += m0;
         pA0 += incAk0;
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK0x0x0TT9x1x4_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=9, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/9)*9;
   #define Nb N
   #define Kb K
   const int Kloop = ((K-1)>>2)<<2, kr = K - Kloop - 1;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (Nb);
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((((lda) << 3)+lda) - Kb), incAn = -(Mb*lda);
   const int incBk = (ldb), incBm = -(Kb*ldb);
   #define incBn 1
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 9
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda), *pA7=pA6+(lda), *pA8=pA7+(lda);
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8;
   register double rB0;
   register double m0, m1, m2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            rA2 = *pA2;
            rA3 = *pA3;
            rA4 = *pA4;
            rA5 = *pA5;
            rA6 = *pA6;
            rA7 = *pA7;
            rA8 = *pA8;
            m0 = rA0 * rB0;
            m1 = rA1 * rB0;
            m2 = rA2 * rB0;

            for (k=Kloop; k; k -= 4) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rA1 = pA1[4];
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rA6 = pA6[4];
               rA7 = pA7[4];
               rA8 = pA8[4];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pA4 += incAk;
               pA5 += incAk;
               pA6 += incAk;
               pA7 += incAk;
               pA8 += incAk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               pA0 += (incAk0);
               pA1 += (incAk0);
               pA2 += (incAk0);
               pA3 += (incAk0);
               pA4 += (incAk0);
               pA5 += (incAk0);
               pA6 += (incAk0);
               pA7 += (incAk0);
               pA8 += (incAk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               pA0 += (((incAk0) << 1));
               pA1 += (((incAk0) << 1));
               pA2 += (((incAk0) << 1));
               pA3 += (((incAk0) << 1));
               pA4 += (((incAk0) << 1));
               pA5 += (((incAk0) << 1));
               pA6 += (((incAk0) << 1));
               pA7 += (((incAk0) << 1));
               pA8 += (((incAk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rA1 = pA1[1];
               rA2 = pA2[1];
               rA3 = pA3[1];
               rA4 = pA4[1];
               rA5 = pA5[1];
               rA6 = pA6[1];
               rA7 = pA7[1];
               rA8 = pA8[1];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rA1 = pA1[2];
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rA6 = pA6[2];
               rA7 = pA7[2];
               rA8 = pA8[2];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               rC0_0 += m0;
               m0 = rA3 * rB0;
               rC1_0 += m1;
               m1 = rA4 * rB0;
               rC2_0 += m2;
               m2 = rA5 * rB0;
               rC3_0 += m0;
               m0 = rA6 * rB0;
               rC4_0 += m1;
               m1 = rA7 * rB0;
               rC5_0 += m2;
               m2 = rA8 * rB0;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rA1 = pA1[3];
               rA2 = pA2[3];
               rA3 = pA3[3];
               rA4 = pA4[3];
               rA5 = pA5[3];
               rA6 = pA6[3];
               rA7 = pA7[3];
               rA8 = pA8[3];
               rC6_0 += m0;
               m0 = rA0 * rB0;
               rC7_0 += m1;
               m1 = rA1 * rB0;
               rC8_0 += m2;
               m2 = rA2 * rB0;
               pA0 += (((incAk0) << 1)+incAk0);
               pA1 += (((incAk0) << 1)+incAk0);
               pA2 += (((incAk0) << 1)+incAk0);
               pA3 += (((incAk0) << 1)+incAk0);
               pA4 += (((incAk0) << 1)+incAk0);
               pA5 += (((incAk0) << 1)+incAk0);
               pA6 += (((incAk0) << 1)+incAk0);
               pA7 += (((incAk0) << 1)+incAk0);
               pA8 += (((incAk0) << 1)+incAk0);
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA3 * rB0;
            rC1_0 += m1;
            m1 = rA4 * rB0;
            rC2_0 += m2;
            m2 = rA5 * rB0;
            rC3_0 += m0;
            m0 = rA6 * rB0;
            rC4_0 += m1;
            m1 = rA7 * rB0;
            rC5_0 += m2;
            m2 = rA8 * rB0;
            pB0 += incBk0;
            rC6_0 += m0;
            rC7_0 += m1;
            rC8_0 += m2;
            pA0 += incAk0;
            pA1 += incAk0;
            pA2 += incAk0;
            pA3 += incAk0;
            pA4 += incAk0;
            pA5 += incAk0;
            pA6 += incAk0;
            pA7 += incAk0;
            pA8 += incAk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            rC4_0 *= rB0;
            rC5_0 *= rB0;
            rC6_0 *= rB0;
            rC7_0 *= rB0;
            rC8_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pA4 += incAm;
            pA5 += incAm;
            pA6 += incAm;
            pA7 += incAm;
            pA8 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pA4 += incAn;
         pA5 += incAn;
         pA6 += incAn;
         pA7 += incAn;
         pA8 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x0TT1x1x4_aX_bX(k, N, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x0TT1x2x4_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=2, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N>>1)<<1;
   #define Kb K
   const int Kloop = ((K-2)>>2)<<2, kr = K - Kloop - 2;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (Nb);
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((lda) - Kb), incAn = -(Mb*lda);
   const int incBk = (ldb), incBm = -(Kb*ldb);
   #define incBn 2
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 1
   const int incCn = (((ldc) << 1)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1;
   register double m0, m1;
   register double rC0_0, rC0_1;
   if (K < 3)
   {
      ATL_dJIK0x0x0TT1x1x1_aX_bX(M, N, K, alpha, A, lda, B, ldb, beta, C, ldc);
      return;
   }
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[1];
            m0 = rA0 * rB0;
            m1 = rA0 * rB1;
            pB0 += incBk0;
            rA0 = pA0[1];
            rB0 = *pB0;
            rB1 = pB0[1];

            pA0 += (incAk0);
            for (k=Kloop; k; k -= 4) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rB1 = pB0[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rB1 = pB0[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rB1 = pB0[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[4];
               rB0 = *pB0;
               rB1 = pB0[1];
               pA0 += incAk;
            } /* end K-loop */
            switch(kr)
            {
            case 1:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rB1 = pB0[1];
               pA0 += (incAk0);
               break;
            case 2:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rB1 = pB0[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rB1 = pB0[1];
               pA0 += (((incAk0) << 1));
               break;
            case 3:
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[1];
               rB0 = *pB0;
               rB1 = pB0[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[2];
               rB0 = *pB0;
               rB1 = pB0[1];
               rC0_0 += m0;
               m0 = rA0 * rB0;
               rC0_1 += m1;
               m1 = rA0 * rB1;
               pB0 += incBk;
               rA0 = pA0[3];
               rB0 = *pB0;
               rB1 = pB0[1];
               pA0 += (((incAk0) << 1)+incAk0);
               break;
            case 0: ;
            }
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rC0_1 += m1;
            m1 = rA0 * rB1;
            pB0 += incBk0;
            rC0_0 += m0;
            rC0_1 += m1;
            pA0 += incAk0;
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            pC0 += incCm;
            pC1 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK0x0x0TT1x1x4_aX_bX(M, k, K, alpha, ca, lda, cb + (Nb), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x0TT0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=9, nu=2, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/9)*9;
   const int Nb = (N>>1)<<1;
   #define Kb K
   const int Kloop = ((K-1)>>2)<<2, kr = K - Kloop - 1;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (lda*Mb);
   const double *stN = B + (Nb);
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 4
   const int incAm = ((((lda) << 3)+lda) - Kb), incAn = -(Mb*lda);
   const int incBk = (ldb), incBm = -(Kb*ldb);
   #define incBn 2
   const int incAk0 = ((incAk) >> 2);
   #define incBk0 incBk
   #define incCm 9
   const int incCn = (((ldc) << 1)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda), *pA7=pA6+(lda), *pA8=pA7+(lda);
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8;
   register double rB0, rB1;
   register double m0, m1;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1, rC8_1;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+8);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = BetaAlpha;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC2_0 = pC0[2];
               rC2_0 *= rA0;
               rC3_0 = pC0[3];
               rC3_0 *= rA0;
               rC4_0 = pC0[4];
               rC4_0 *= rA0;
               rC5_0 = pC0[5];
               rC5_0 *= rA0;
               rC6_0 = pC0[6];
               rC6_0 *= rA0;
               rC7_0 = pC0[7];
               rC7_0 *= rA0;
               rC8_0 = pC0[8];
               rC8_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC2_1 = pC1[2];
               rC2_1 *= rA0;
               rC3_1 = pC1[3];
               rC3_1 *= rA0;
               rC4_1 = pC1[4];
               rC4_1 *= rA0;
               rC5_1 = pC1[5];
               rC5_1 *= rA0;
               rC6_1 = pC1[6];
               rC6_1 *= rA0;
               rC7_1 = pC1[7];
               rC7_1 *= rA0;
               rC8_1 = pC1[8];
               rC8_1 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rA6 = *pA6;
               rA7 = *pA7;
               rA8 = *pA8;
               m0 = rA0 * rB0;
               rB1 = pB0[1];
               m1 = rA1 * rB0;

               for (k=Kloop; k; k -= 4) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[1];
                  rB0 = *pB0;
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rA3 = pA3[1];
                  rA4 = pA4[1];
                  rA5 = pA5[1];
                  rA6 = pA6[1];
                  rA7 = pA7[1];
                  rA8 = pA8[1];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[2];
                  rB0 = *pB0;
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rA3 = pA3[2];
                  rA4 = pA4[2];
                  rA5 = pA5[2];
                  rA6 = pA6[2];
                  rA7 = pA7[2];
                  rA8 = pA8[2];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[3];
                  rB0 = *pB0;
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rA3 = pA3[3];
                  rA4 = pA4[3];
                  rA5 = pA5[3];
                  rA6 = pA6[3];
                  rA7 = pA7[3];
                  rA8 = pA8[3];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[4];
                  rB0 = *pB0;
                  rA1 = pA1[4];
                  rA2 = pA2[4];
                  rA3 = pA3[4];
                  rA4 = pA4[4];
                  rA5 = pA5[4];
                  rA6 = pA6[4];
                  rA7 = pA7[4];
                  rA8 = pA8[4];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  pA0 += incAk;
                  pA1 += incAk;
                  pA2 += incAk;
                  pA3 += incAk;
                  pA4 += incAk;
                  pA5 += incAk;
                  pA6 += incAk;
                  pA7 += incAk;
                  pA8 += incAk;
               } /* end K-loop */
               switch(kr)
               {
               case 1:
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[1];
                  rB0 = *pB0;
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rA3 = pA3[1];
                  rA4 = pA4[1];
                  rA5 = pA5[1];
                  rA6 = pA6[1];
                  rA7 = pA7[1];
                  rA8 = pA8[1];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  pA0 += (incAk0);
                  pA1 += (incAk0);
                  pA2 += (incAk0);
                  pA3 += (incAk0);
                  pA4 += (incAk0);
                  pA5 += (incAk0);
                  pA6 += (incAk0);
                  pA7 += (incAk0);
                  pA8 += (incAk0);
                  break;
               case 2:
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[1];
                  rB0 = *pB0;
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rA3 = pA3[1];
                  rA4 = pA4[1];
                  rA5 = pA5[1];
                  rA6 = pA6[1];
                  rA7 = pA7[1];
                  rA8 = pA8[1];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[2];
                  rB0 = *pB0;
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rA3 = pA3[2];
                  rA4 = pA4[2];
                  rA5 = pA5[2];
                  rA6 = pA6[2];
                  rA7 = pA7[2];
                  rA8 = pA8[2];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  pA0 += (((incAk0) << 1));
                  pA1 += (((incAk0) << 1));
                  pA2 += (((incAk0) << 1));
                  pA3 += (((incAk0) << 1));
                  pA4 += (((incAk0) << 1));
                  pA5 += (((incAk0) << 1));
                  pA6 += (((incAk0) << 1));
                  pA7 += (((incAk0) << 1));
                  pA8 += (((incAk0) << 1));
                  break;
               case 3:
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[1];
                  rB0 = *pB0;
                  rA1 = pA1[1];
                  rA2 = pA2[1];
                  rA3 = pA3[1];
                  rA4 = pA4[1];
                  rA5 = pA5[1];
                  rA6 = pA6[1];
                  rA7 = pA7[1];
                  rA8 = pA8[1];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[2];
                  rB0 = *pB0;
                  rA1 = pA1[2];
                  rA2 = pA2[2];
                  rA3 = pA3[2];
                  rA4 = pA4[2];
                  rA5 = pA5[2];
                  rA6 = pA6[2];
                  rA7 = pA7[2];
                  rA8 = pA8[2];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  rC0_0 += m0;
                  m0 = rA2 * rB0;
                  rC1_0 += m1;
                  m1 = rA3 * rB0;
                  rC2_0 += m0;
                  m0 = rA4 * rB0;
                  rC3_0 += m1;
                  m1 = rA5 * rB0;
                  rC4_0 += m0;
                  m0 = rA6 * rB0;
                  rC5_0 += m1;
                  m1 = rA7 * rB0;
                  rC6_0 += m0;
                  m0 = rA8 * rB0;
                  rC7_0 += m1;
                  m1 = rA0 * rB1;
                  rC8_0 += m0;
                  m0 = rA1 * rB1;
                  rC0_1 += m1;
                  m1 = rA2 * rB1;
                  rC1_1 += m0;
                  m0 = rA3 * rB1;
                  rC2_1 += m1;
                  m1 = rA4 * rB1;
                  rC3_1 += m0;
                  m0 = rA5 * rB1;
                  rC4_1 += m1;
                  m1 = rA6 * rB1;
                  rC5_1 += m0;
                  m0 = rA7 * rB1;
                  rC6_1 += m1;
                  m1 = rA8 * rB1;
                  pB0 += incBk;
                  rA0 = pA0[3];
                  rB0 = *pB0;
                  rA1 = pA1[3];
                  rA2 = pA2[3];
                  rA3 = pA3[3];
                  rA4 = pA4[3];
                  rA5 = pA5[3];
                  rA6 = pA6[3];
                  rA7 = pA7[3];
                  rA8 = pA8[3];
                  rB1 = pB0[1];
                  rC7_1 += m0;
                  m0 = rA0 * rB0;
                  rC8_1 += m1;
                  m1 = rA1 * rB0;
                  pA0 += (((incAk0) << 1)+incAk0);
                  pA1 += (((incAk0) << 1)+incAk0);
                  pA2 += (((incAk0) << 1)+incAk0);
                  pA3 += (((incAk0) << 1)+incAk0);
                  pA4 += (((incAk0) << 1)+incAk0);
                  pA5 += (((incAk0) << 1)+incAk0);
                  pA6 += (((incAk0) << 1)+incAk0);
                  pA7 += (((incAk0) << 1)+incAk0);
                  pA8 += (((incAk0) << 1)+incAk0);
                  break;
               case 0: ;
               }
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA2 * rB0;
               rC1_0 += m1;
               m1 = rA3 * rB0;
               rC2_0 += m0;
               m0 = rA4 * rB0;
               rC3_0 += m1;
               m1 = rA5 * rB0;
               rC4_0 += m0;
               m0 = rA6 * rB0;
               rC5_0 += m1;
               m1 = rA7 * rB0;
               rC6_0 += m0;
               m0 = rA8 * rB0;
               rC7_0 += m1;
               m1 = rA0 * rB1;
               rC8_0 += m0;
               m0 = rA1 * rB1;
               rC0_1 += m1;
               m1 = rA2 * rB1;
               rC1_1 += m0;
               m0 = rA3 * rB1;
               rC2_1 += m1;
               m1 = rA4 * rB1;
               rC3_1 += m0;
               m0 = rA5 * rB1;
               rC4_1 += m1;
               m1 = rA6 * rB1;
               rC5_1 += m0;
               m0 = rA7 * rB1;
               rC6_1 += m1;
               m1 = rA8 * rB1;
               pB0 += incBk0;
               rC7_1 += m0;
               rC8_1 += m1;
               pA0 += incAk0;
               pA1 += incAk0;
               pA2 += incAk0;
               pA3 += incAk0;
               pA4 += incAk0;
               pA5 += incAk0;
               pA6 += incAk0;
               pA7 += incAk0;
               pA8 += incAk0;
               rB0 = alpha;
               rC0_0 *= rB0;
               rC0_1 *= rB0;
               rC1_0 *= rB0;
               rC1_1 *= rB0;
               rC2_0 *= rB0;
               rC2_1 *= rB0;
               rC3_0 *= rB0;
               rC3_1 *= rB0;
               rC4_0 *= rB0;
               rC4_1 *= rB0;
               rC5_0 *= rB0;
               rC5_1 *= rB0;
               rC6_0 *= rB0;
               rC6_1 *= rB0;
               rC7_0 *= rB0;
               rC7_1 *= rB0;
               rC8_0 *= rB0;
               rC8_1 *= rB0;
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               pC0[2] = rC2_0;
               pC0[3] = rC3_0;
               pC0[4] = rC4_0;
               pC0[5] = rC5_0;
               pC0[6] = rC6_0;
               pC0[7] = rC7_0;
               pC0[8] = rC8_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               pC1[2] = rC2_1;
               pC1[3] = rC3_1;
               pC1[4] = rC4_1;
               pC1[5] = rC5_1;
               pC1[6] = rC6_1;
               pC1[7] = rC7_1;
               pC1[8] = rC8_1;
               pC0 += incCm;
               pC1 += incCm;
               pA0 += incAm;
               pA1 += incAm;
               pA2 += incAm;
               pA3 += incAm;
               pA4 += incAm;
               pA5 += incAm;
               pA6 += incAm;
               pA7 += incAm;
               pA8 += incAm;
               pB0 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pA0 += incAn;
            pA1 += incAn;
            pA2 += incAn;
            pA3 += incAn;
            pA4 += incAn;
            pA5 += incAn;
            pA6 += incAn;
            pA7 += incAn;
            pA8 += incAn;
            pB0 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_dJIK0x0x0TT9x1x4_aX_bX(M, k, K, alpha, ca, lda, cb + (Nb), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_dJIK0x0x0TT1x2x4_aX_bX(k, Nb, K, alpha, ca + (Mb*lda), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
