#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
void ATL_sJIK80x80x80TT0x0x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=80, NB=80, KB=80, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=2, ku=1, pf=0
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + (((lda) << 6)+((lda) << 4));
   const float *stN = B + 80;
   #define incAk 1
   const int incAm = ((((lda) << 1)) - 80), incAn = -(((lda) << 6)+((lda) << 4));
   const int incBk = (ldb), incBm = -(((ldb) << 6)+((ldb) << 4));
   #define incBn 2
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 1)) - 80;
   float *pC0=C, *pC1=pC0+(ldc);
   const float *pA0=A, *pA1=pA0+(lda);
   const float *pB0=B;
   register int k;
   register float rA0, rA1;
   register float rB0, rB1;
   register float m0, m1;
   register float rC0_0, rC1_0, rC0_1, rC1_1;
   do /* N-loop */
   {
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = *pA1;
         rB1 = pB0[1];
         m1 = rA1 * rB0;

/*
 *       Peel first 1 iterations for C assignment
 */
         rC0_0 = m0;
         m0 = rA0 * rB1;
         rC1_0 = m1;
         m1 = rA1 * rB1;
         pB0 += incBk;
         rA0 = pA0[1];
         rB0 = *pB0;
         rA1 = pA1[1];
         rB1 = pB0[1];
         rC0_1 = m0;
         m0 = rA0 * rB0;
         rC1_1 = m1;
         m1 = rA1 * rB0;
         pA0 += incAk;
         pA1 += incAk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 78; k++) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rC1_0 += m1;
            m1 = rA1 * rB1;
            pB0 += incBk;
            rA0 = pA0[1];
            rB0 = *pB0;
            rA1 = pA1[1];
            rB1 = pB0[1];
            rC0_1 += m0;
            m0 = rA0 * rB0;
            rC1_1 += m1;
            m1 = rA1 * rB0;
            pA0 += incAk;
            pA1 += incAk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB1;
         rC1_0 += m1;
         m1 = rA1 * rB1;
         pB0 += incBk0;
         rC0_1 += m0;
         rC1_1 += m1;
         pA0 += incAk0;
         pA1 += incAk0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
